SystemOrganization addCategory: #SmalltalkQuiz!

Object subclass: #STQCanUnderstandMessage
	instanceVariableNames: 'theClass choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!STQCanUnderstandMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:39'!
allSelectors

	^(CompiledMethod allInstances collect:[:each| each selector]) asSet! !

!STQCanUnderstandMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:43'!
choicesString

^' (1) ', (choices at:1),'
 (2) ', (choices at:2),'
 (3) ', (choices at:3),'
 (4) ', (choices at:4)! !

!STQCanUnderstandMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:39'!
huhu

	| allSelectors distinguishedSelectors |
	theClass := Smalltalk allClasses atRandom.
	
	allSelectors := self allSelectors.
	distinguishedSelectors := allSelectors distinguishedBy: [:each| theClass canUnderstand: each].
	choices := Set new.
	choices add: distinguishedSelectors selectedOnes atRandom.
	[choices add: distinguishedSelectors rejectedOnes atRandom.
		choices size < 4 ] whileTrue.
	choices := choices asArray shuffled.! !

!STQCanUnderstandMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:44'!
questionAndChoicesStirng

	^self questionString, String cr, self choicesString! !

!STQCanUnderstandMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/12/2010 18:41'!
questionString

	^'Which one of the messages below can be understood by ', theClass printString , '?'! !

Object subclass: #STQuizUnderstandsMessage
	instanceVariableNames: 'theSelector choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:51'!
choices

	^choices! !

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:51'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 19:06'!
correctChoice

	| corrects |
	corrects := self choices select: [:each | each canUnderstand: theSelector ].
	self assert: [corrects size = 1].
	^corrects anyOne! !

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:48'!
doJob

	| distinguishment choiceSet |
	theSelector := CompiledMethod allInstances atRandom selector.

	[
		distinguishment := Smalltalk allClasses distinguishedBy: [:each| each canUnderstand: 	theSelector ].
		distinguishment selectedOnes size>=1 and: [distinguishment rejectedOnes size>=3]
	] whileFalse.

	choiceSet := Set new.
	choiceSet add: distinguishment selectedOnes atRandom.
	[choiceSet size < 4] whileTrue:
		[choiceSet add: distinguishment rejectedOnes atRandom] .

	choices := choiceSet asArray shuffled! !

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 19:06'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:51'!
questionAndChoicesStirng

	^self questionString, String cr, self choicesString.! !

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:53'!
questionString

	^'Which one of classes below can understand message #', theSelector  , '?'! !

!STQuizUnderstandsMessage methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 19:09'!
rightOrWrongIfUserChoosed: aSmallInteger 

	^self indexOfCorrectChoice = aSmallInteger! !

Object subclass: #SmalltalkNegativeQuiz
	instanceVariableNames: 'choices theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:07'!
answer

	^theClass! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:02'!
beRandom

	| allclasses class choice exchoice |
	allclasses := Smalltalk allClasses.

	allclasses atRandom.
	[class := allclasses atRandom.
	class allSubclasses size < 3 ] whileTrue.

	choice := Set new. 
	[choice add:(class allSubclasses atRandom).
	choice size = 3 ]whileFalse.

	[exchoice := allclasses atRandom.
	class ~= exchoice and: [(class inheritsFrom:exchoice) not].]whileFalse.

	choice add:exchoice.


	self choices: choice asArray shuffled.
	self theClass: class.! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:05'!
choices

	^choices! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/2/2010 17:58'!
choices: aSet 
	
	choices := aSet! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:05'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:06'!
correctChoice

	| correctOne |
	correctOne := self choices select: [:each| (each inheritsFrom: self answer) not].
	self assert: [correctOne size = 1 ].
	^correctOne anyOne! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:07'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:05'!
questionAndChoicesStirng

	^self questionString, String cr, self choicesString.! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/8/2010 18:04'!
questionString

	^'Which one of the classes below is not subclass of ', theClass asString , '?'! !

!SmalltalkNegativeQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 4/2/2010 17:59'!
theClass: aClass 

	theClass := aClass! !

Object subclass: #SmalltalkQuiz
	instanceVariableNames: 'answer choices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:39'!
answer

	^answer! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 23:57'!
answer: aClass 

	answer := aClass! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:57'!
beOne

	| subclasses classes wrongCandidates wrongOne |
	classes := Smalltalk allClasses.
	answer :=classes atRandom.
	subclasses := answer allSubclasses.
	subclasses isEmpty ifTrue: [^false].
	wrongCandidates := classes copyWithoutAll: subclasses.
	choices := OrderedCollection new.
	choices add: subclasses atRandom.
	3 timesRepeat:
		[wrongOne := wrongCandidates atRandom.
		choices add: (wrongCandidates remove:wrongOne)].
	choices := choices shuffled.
	^true! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:26'!
choices

	^choices! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 23:59'!
choices: anOrderedCollection 

	choices := anOrderedCollection! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:49'!
choicesString

	^'  (1)  ' , (self choices at:1) asString, String cr,
	'  (2)  ' , (self choices at:2) asString, String cr,
	'  (3)  ' , (self choices at:3) asString, String cr,
	'  (4)  ' , (self choices at:4) asString, String cr
! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:46'!
correctChoice

	| correctOne |
	correctOne := self choices select: [:each| each inheritsFrom: self answer].
	self assert: [correctOne size = 1 ].
	^correctOne anyOne! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:52'!
indexOfCorrectChoice

	^self choices indexOf: self correctChoice! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:59'!
questionAndChoicesStirng

	^self questionString, String cr, self choicesString.! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:51'!
questionString

	^'Which one of the classes below is subclass of ', answer asString , '?'! !

!SmalltalkQuiz methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 21:30'!
runToGetOne

	[self beOne] whileFalse! !

Object subclass: #SmalltalkQuizMaker
	instanceVariableNames: 'quizToMake classes subclasses wrongCandidates choicesUnshuffled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmalltalkQuiz'!

!SmalltalkQuizMaker methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2010 00:03'!
addOneWrongCandiateToChoicesUnshuffled

	| wrongOne |
	wrongOne := wrongCandidates atRandom.
	choicesUnshuffled add: (wrongCandidates remove:wrongOne)! !

!SmalltalkQuizMaker methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2010 00:03'!
completeChoices

	wrongCandidates := classes copyWithoutAll: subclasses.
	choicesUnshuffled := OrderedCollection new.
	choicesUnshuffled add: subclasses atRandom.
	3 timesRepeat:
		[self addOneWrongCandiateToChoicesUnshuffled].
	quizToMake choices: choicesUnshuffled shuffled.! !

!SmalltalkQuizMaker methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2010 00:05'!
doYourJob

	quizToMake := SmalltalkQuiz new.
	self loopUntilClassHasMoreThanOneSubclass.
	self completeChoices! !

!SmalltalkQuizMaker methodsFor: 'as yet unclassified' stamp: 'hjo 4/1/2010 00:05'!
loopUntilClassHasMoreThanOneSubclass

	| answer |
	[classes := Smalltalk allClasses.
	answer :=classes atRandom.
	subclasses := answer allSubclasses.
	subclasses isEmpty] whileTrue.
	quizToMake answer: answer! !

!SmalltalkQuizMaker methodsFor: 'as yet unclassified' stamp: 'hjo 3/31/2010 23:59'!
quizToMake

	^quizToMake! !
